/*
    license
    copyright (c) 1998-2007 Kazuki IWAMOTO http://www.maid.org/ iwm@maid.org

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
#include <tchar.h>
#include "dialog.h"
#include "license.h"
#include "other.h"
#include "resource.h"


/******************************************************************************
*                                                                             *
* ja:CZX̊֐                                                         *
*                                                                             *
******************************************************************************/
static LPCTSTR lpszGnuGpl =
_T("\t\t    GNU GENERAL PUBLIC LICENSE\r\n")
_T("\t\t       Version 2, June 1991\r\n")
_T("\r\n")
_T(" Copyright (C) 1989, 1991 Free Software Foundation, Inc.\r\n")
_T("     59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\r\n")
_T(" Everyone is permitted to copy and distribute verbatim copies\r\n")
_T(" of this license document, but changing it is not allowed.\r\n")
_T("\r\n")
_T("\t\t\t    Preamble\r\n")
_T("\r\n")
_T("  The licenses for most software are designed to take away your\r\n")
_T("freedom to share and change it.  By contrast, the GNU General Public\r\n")
_T("License is intended to guarantee your freedom to share and change free\r\n")
_T("software--to make sure the software is free for all its users.  This\r\n")
_T("General Public License applies to most of the Free Software\r\n")
_T("Foundation's software and to any other program whose authors commit to\r\n")
_T("using it.  (Some other Free Software Foundation software is covered by\r\n")
_T("the GNU Library General Public License instead.)  You can apply it to\r\n")
_T("your programs, too.\r\n")
_T("\r\n")
_T("  When we speak of free software, we are referring to freedom, not\r\n")
_T("price.  Our General Public Licenses are designed to make sure that you\r\n")
_T("have the freedom to distribute copies of free software (and charge for\r\n")
_T("this service if you wish), that you receive source code or can get it\r\n")
_T("if you want it, that you can change the software or use pieces of it\r\n")
_T("in new free programs; and that you know you can do these things.\r\n")
_T("\r\n")
_T("  To protect your rights, we need to make restrictions that forbid\r\n")
_T("anyone to deny you these rights or to ask you to surrender the rights.\r\n")
_T("These restrictions translate to certain responsibilities for you if you\r\n")
_T("distribute copies of the software, or if you modify it.\r\n")
_T("\r\n")
_T("  For example, if you distribute copies of such a program, whether\r\n")
_T("gratis or for a fee, you must give the recipients all the rights that\r\n")
_T("you have.  You must make sure that they, too, receive or can get the\r\n")
_T("source code.  And you must show them these terms so they know their\r\n")
_T("rights.\r\n")
_T("\r\n")
_T("  We protect your rights with two steps: (1) copyright the software, and\r\n")
_T("(2) offer you this license which gives you legal permission to copy,\r\n")
_T("distribute and/or modify the software.\r\n")
_T("\r\n")
_T("  Also, for each author's protection and ours, we want to make certain\r\n")
_T("that everyone understands that there is no warranty for this free\r\n")
_T("software.  If the software is modified by someone else and passed on, we\r\n")
_T("want its recipients to know that what they have is not the original, so\r\n")
_T("that any problems introduced by others will not reflect on the original\r\n")
_T("authors' reputations.\r\n")
_T("\r\n")
_T("  Finally, any free program is threatened constantly by software\r\n")
_T("patents.  We wish to avoid the danger that redistributors of a free\r\n")
_T("program will individually obtain patent licenses, in effect making the\r\n")
_T("program proprietary.  To prevent this, we have made it clear that any\r\n")
_T("patent must be licensed for everyone's free use or not licensed at all.\r\n")
_T("\r\n")
_T("  The precise terms and conditions for copying, distribution and\r\n")
_T("modification follow.\r\n")
_T("\f\r\n")
_T("\t\t    GNU GENERAL PUBLIC LICENSE\r\n")
_T("   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION\r\n")
_T("\r\n")
_T("  0. This License applies to any program or other work which contains\r\n")
_T("a notice placed by the copyright holder saying it may be distributed\r\n")
_T("under the terms of this General Public License.  The \"Program\", below,\r\n")
_T("refers to any such program or work, and a \"work based on the Program\"\r\n")
_T("means either the Program or any derivative work under copyright law:\r\n")
_T("that is to say, a work containing the Program or a portion of it,\r\n")
_T("either verbatim or with modifications and/or translated into another\r\n")
_T("language.  (Hereinafter, translation is included without limitation in\r\n")
_T("the term \"modification\".)  Each licensee is addressed as \"you\".\r\n")
_T("\r\n")
_T("Activities other than copying, distribution and modification are not\r\n")
_T("covered by this License; they are outside its scope.  The act of\r\n")
_T("running the Program is not restricted, and the output from the Program\r\n")
_T("is covered only if its contents constitute a work based on the\r\n")
_T("Program (independent of having been made by running the Program).\r\n")
_T("Whether that is true depends on what the Program does.\r\n")
_T("\r\n")
_T("  1. You may copy and distribute verbatim copies of the Program's\r\n")
_T("source code as you receive it, in any medium, provided that you\r\n")
_T("conspicuously and appropriately publish on each copy an appropriate\r\n")
_T("copyright notice and disclaimer of warranty; keep intact all the\r\n")
_T("notices that refer to this License and to the absence of any warranty;\r\n")
_T("and give any other recipients of the Program a copy of this License\r\n")
_T("along with the Program.\r\n")
_T("\r\n")
_T("You may charge a fee for the physical act of transferring a copy, and\r\n")
_T("you may at your option offer warranty protection in exchange for a fee.\r\n")
_T("\r\n")
_T("  2. You may modify your copy or copies of the Program or any portion\r\n")
_T("of it, thus forming a work based on the Program, and copy and\r\n")
_T("distribute such modifications or work under the terms of Section 1\r\n")
_T("above, provided that you also meet all of these conditions:\r\n")
_T("\r\n")
_T("    a) You must cause the modified files to carry prominent notices\r\n")
_T("    stating that you changed the files and the date of any change.\r\n")
_T("\r\n")
_T("    b) You must cause any work that you distribute or publish, that in\r\n")
_T("    whole or in part contains or is derived from the Program or any\r\n")
_T("    part thereof, to be licensed as a whole at no charge to all third\r\n")
_T("    parties under the terms of this License.\r\n")
_T("\r\n")
_T("    c) If the modified program normally reads commands interactively\r\n")
_T("    when run, you must cause it, when started running for such\r\n")
_T("    interactive use in the most ordinary way, to print or display an\r\n")
_T("    announcement including an appropriate copyright notice and a\r\n")
_T("    notice that there is no warranty (or else, saying that you provide\r\n")
_T("    a warranty) and that users may redistribute the program under\r\n")
_T("    these conditions, and telling the user how to view a copy of this\r\n")
_T("    License.  (Exception: if the Program itself is interactive but\r\n")
_T("    does not normally print such an announcement, your work based on\r\n")
_T("    the Program is not required to print an announcement.)\r\n")
_T("\f\r\n")
_T("These requirements apply to the modified work as a whole.  If\r\n")
_T("identifiable sections of that work are not derived from the Program,\r\n")
_T("and can be reasonably considered independent and separate works in\r\n")
_T("themselves, then this License, and its terms, do not apply to those\r\n")
_T("sections when you distribute them as separate works.  But when you\r\n")
_T("distribute the same sections as part of a whole which is a work based\r\n")
_T("on the Program, the distribution of the whole must be on the terms of\r\n")
_T("this License, whose permissions for other licensees extend to the\r\n")
_T("entire whole, and thus to each and every part regardless of who wrote it.\r\n")
_T("\r\n")
_T("Thus, it is not the intent of this section to claim rights or contest\r\n")
_T("your rights to work written entirely by you; rather, the intent is to\r\n")
_T("exercise the right to control the distribution of derivative or\r\n")
_T("collective works based on the Program.\r\n")
_T("\r\n")
_T("In addition, mere aggregation of another work not based on the Program\r\n")
_T("with the Program (or with a work based on the Program) on a volume of\r\n")
_T("a storage or distribution medium does not bring the other work under\r\n")
_T("the scope of this License.\r\n")
_T("\r\n")
_T("  3. You may copy and distribute the Program (or a work based on it,\r\n")
_T("under Section 2) in object code or executable form under the terms of\r\n")
_T("Sections 1 and 2 above provided that you also do one of the following:\r\n")
_T("\r\n")
_T("    a) Accompany it with the complete corresponding machine-readable\r\n")
_T("    source code, which must be distributed under the terms of Sections\r\n")
_T("    1 and 2 above on a medium customarily used for software interchange; or,\r\n")
_T("\r\n")
_T("    b) Accompany it with a written offer, valid for at least three\r\n")
_T("    years, to give any third party, for a charge no more than your\r\n")
_T("    cost of physically performing source distribution, a complete\r\n")
_T("    machine-readable copy of the corresponding source code, to be\r\n")
_T("    distributed under the terms of Sections 1 and 2 above on a medium\r\n")
_T("    customarily used for software interchange; or,\r\n")
_T("\r\n")
_T("    c) Accompany it with the information you received as to the offer\r\n")
_T("    to distribute corresponding source code.  (This alternative is\r\n")
_T("    allowed only for noncommercial distribution and only if you\r\n")
_T("    received the program in object code or executable form with such\r\n")
_T("    an offer, in accord with Subsection b above.)\r\n")
_T("\r\n")
_T("The source code for a work means the preferred form of the work for\r\n")
_T("making modifications to it.  For an executable work, complete source\r\n")
_T("code means all the source code for all modules it contains, plus any\r\n")
_T("associated interface definition files, plus the scripts used to\r\n")
_T("control compilation and installation of the executable.  However, as a\r\n")
_T("special exception, the source code distributed need not include\r\n")
_T("anything that is normally distributed (in either source or binary\r\n")
_T("form) with the major components (compiler, kernel, and so on) of the\r\n")
_T("operating system on which the executable runs, unless that component\r\n")
_T("itself accompanies the executable.\r\n")
_T("\r\n")
_T("If distribution of executable or object code is made by offering\r\n")
_T("access to copy from a designated place, then offering equivalent\r\n")
_T("access to copy the source code from the same place counts as\r\n")
_T("distribution of the source code, even though third parties are not\r\n")
_T("compelled to copy the source along with the object code.\r\n")
_T("\f\r\n")
_T("  4. You may not copy, modify, sublicense, or distribute the Program\r\n")
_T("except as expressly provided under this License.  Any attempt\r\n")
_T("otherwise to copy, modify, sublicense or distribute the Program is\r\n")
_T("void, and will automatically terminate your rights under this License.\r\n")
_T("However, parties who have received copies, or rights, from you under\r\n")
_T("this License will not have their licenses terminated so long as such\r\n")
_T("parties remain in full compliance.\r\n")
_T("\r\n")
_T("  5. You are not required to accept this License, since you have not\r\n")
_T("signed it.  However, nothing else grants you permission to modify or\r\n")
_T("distribute the Program or its derivative works.  These actions are\r\n")
_T("prohibited by law if you do not accept this License.  Therefore, by\r\n")
_T("modifying or distributing the Program (or any work based on the\r\n")
_T("Program), you indicate your acceptance of this License to do so, and\r\n")
_T("all its terms and conditions for copying, distributing or modifying\r\n")
_T("the Program or works based on it.\r\n")
_T("\r\n")
_T("  6. Each time you redistribute the Program (or any work based on the\r\n")
_T("Program), the recipient automatically receives a license from the\r\n")
_T("original licensor to copy, distribute or modify the Program subject to\r\n")
_T("these terms and conditions.  You may not impose any further\r\n")
_T("restrictions on the recipients' exercise of the rights granted herein.\r\n")
_T("You are not responsible for enforcing compliance by third parties to\r\n")
_T("this License.\r\n")
_T("\r\n")
_T("  7. If, as a consequence of a court judgment or allegation of patent\r\n")
_T("infringement or for any other reason (not limited to patent issues),\r\n")
_T("conditions are imposed on you (whether by court order, agreement or\r\n")
_T("otherwise) that contradict the conditions of this License, they do not\r\n")
_T("excuse you from the conditions of this License.  If you cannot\r\n")
_T("distribute so as to satisfy simultaneously your obligations under this\r\n")
_T("License and any other pertinent obligations, then as a consequence you\r\n")
_T("may not distribute the Program at all.  For example, if a patent\r\n")
_T("license would not permit royalty-free redistribution of the Program by\r\n")
_T("all those who receive copies directly or indirectly through you, then\r\n")
_T("the only way you could satisfy both it and this License would be to\r\n")
_T("refrain entirely from distribution of the Program.\r\n")
_T("\r\n")
_T("If any portion of this section is held invalid or unenforceable under\r\n")
_T("any particular circumstance, the balance of the section is intended to\r\n")
_T("apply and the section as a whole is intended to apply in other\r\n")
_T("circumstances.\r\n")
_T("\r\n")
_T("It is not the purpose of this section to induce you to infringe any\r\n")
_T("patents or other property right claims or to contest validity of any\r\n")
_T("such claims; this section has the sole purpose of protecting the\r\n")
_T("integrity of the free software distribution system, which is\r\n")
_T("implemented by public license practices.  Many people have made\r\n")
_T("generous contributions to the wide range of software distributed\r\n")
_T("through that system in reliance on consistent application of that\r\n")
_T("system; it is up to the author/donor to decide if he or she is willing\r\n")
_T("to distribute software through any other system and a licensee cannot\r\n")
_T("impose that choice.\r\n")
_T("\r\n")
_T("This section is intended to make thoroughly clear what is believed to\r\n")
_T("be a consequence of the rest of this License.\r\n")
_T("\f\r\n")
_T("  8. If the distribution and/or use of the Program is restricted in\r\n")
_T("certain countries either by patents or by copyrighted interfaces, the\r\n")
_T("original copyright holder who places the Program under this License\r\n")
_T("may add an explicit geographical distribution limitation excluding\r\n")
_T("those countries, so that distribution is permitted only in or among\r\n")
_T("countries not thus excluded.  In such case, this License incorporates\r\n")
_T("the limitation as if written in the body of this License.\r\n")
_T("\r\n")
_T("  9. The Free Software Foundation may publish revised and/or new versions\r\n")
_T("of the General Public License from time to time.  Such new versions will\r\n")
_T("be similar in spirit to the present version, but may differ in detail to\r\n")
_T("address new problems or concerns.\r\n")
_T("\r\n")
_T("Each version is given a distinguishing version number.  If the Program\r\n")
_T("specifies a version number of this License which applies to it and \"any\r\n")
_T("later version\", you have the option of following the terms and conditions\r\n")
_T("either of that version or of any later version published by the Free\r\n")
_T("Software Foundation.  If the Program does not specify a version number of\r\n")
_T("this License, you may choose any version ever published by the Free Software\r\n")
_T("Foundation.\r\n")
_T("\r\n")
_T("  10. If you wish to incorporate parts of the Program into other free\r\n")
_T("programs whose distribution conditions are different, write to the author\r\n")
_T("to ask for permission.  For software which is copyrighted by the Free\r\n")
_T("Software Foundation, write to the Free Software Foundation; we sometimes\r\n")
_T("make exceptions for this.  Our decision will be guided by the two goals\r\n")
_T("of preserving the free status of all derivatives of our free software and\r\n")
_T("of promoting the sharing and reuse of software generally.\r\n")
_T("\r\n")
_T("\t\t\t    NO WARRANTY\r\n")
_T("\r\n")
_T("  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY\r\n")
_T("FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN\r\n")
_T("OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES\r\n")
_T("PROVIDE THE PROGRAM \"AS IS\" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED\r\n")
_T("OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF\r\n")
_T("MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS\r\n")
_T("TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE\r\n")
_T("PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,\r\n")
_T("REPAIR OR CORRECTION.\r\n")
_T("\r\n")
_T("  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING\r\n")
_T("WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR\r\n")
_T("REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,\r\n")
_T("INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING\r\n")
_T("OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED\r\n")
_T("TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY\r\n")
_T("YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER\r\n")
_T("PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE\r\n")
_T("POSSIBILITY OF SUCH DAMAGES.\r\n")
_T("\r\n")
_T("\t\t     END OF TERMS AND CONDITIONS\r\n")
_T("\f\r\n")
_T("\t    How to Apply These Terms to Your New Programs\r\n")
_T("\r\n")
_T("  If you develop a new program, and you want it to be of the greatest\r\n")
_T("possible use to the public, the best way to achieve this is to make it\r\n")
_T("free software which everyone can redistribute and change under these terms.\r\n")
_T("\r\n")
_T("  To do so, attach the following notices to the program.  It is safest\r\n")
_T("to attach them to the start of each source file to most effectively\r\n")
_T("convey the exclusion of warranty; and each file should have at least\r\n")
_T("the \"copyright\" line and a pointer to where the full notice is found.\r\n")
_T("\r\n")
_T("    <one line to give the program's name and a brief idea of what it does.>\r\n")
_T("    Copyright (C) <year>  <name of author>\r\n")
_T("\r\n")
_T("    This program is free software; you can redistribute it and/or modify\r\n")
_T("    it under the terms of the GNU General Public License as published by\r\n")
_T("    the Free Software Foundation; either version 2 of the License, or\r\n")
_T("    (at your option) any later version.\r\n")
_T("\r\n")
_T("    This program is distributed in the hope that it will be useful,\r\n")
_T("    but WITHOUT ANY WARRANTY; without even the implied warranty of\r\n")
_T("    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\r\n")
_T("    GNU General Public License for more details.\r\n")
_T("\r\n")
_T("    You should have received a copy of the GNU General Public License\r\n")
_T("    along with this program; if not, write to the Free Software\r\n")
_T("    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA\r\n")
_T("\r\n")
_T("\r\n")
_T("Also add information on how to contact you by electronic and paper mail.\r\n")
_T("\r\n")
_T("If the program is interactive, make it output a short notice like this\r\n")
_T("when it starts in an interactive mode:\r\n")
_T("\r\n")
_T("    Gnomovision version 69, Copyright (C) year  name of author\r\n")
_T("    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.\r\n")
_T("    This is free software, and you are welcome to redistribute it\r\n")
_T("    under certain conditions; type `show c' for details.\r\n")
_T("\r\n")
_T("The hypothetical commands `show w' and `show c' should show the appropriate\r\n")
_T("parts of the General Public License.  Of course, the commands you use may\r\n")
_T("be called something other than `show w' and `show c'; they could even be\r\n")
_T("mouse-clicks or menu items--whatever suits your program.\r\n")
_T("\r\n")
_T("You should also get your employer (if you work as a programmer) or your\r\n")
_T("school, if any, to sign a \"copyright disclaimer\" for the program, if\r\n")
_T("necessary.  Here is a sample; alter the names:\r\n")
_T("\r\n")
_T("  Yoyodyne, Inc., hereby disclaims all copyright interest in the program\r\n")
_T("  `Gnomovision' (which makes passes at compilers) written by James Hacker.\r\n")
_T("\r\n")
_T("  <signature of Ty Coon>, 1 April 1989\r\n")
_T("  Ty Coon, President of Vice\r\n")
_T("\r\n")
_T("This General Public License does not permit incorporating your program into\r\n")
_T("proprietary programs.  If your program is a subroutine library, you may\r\n")
_T("consider it more useful to permit linking proprietary applications with the\r\n")
_T("library.  If this is what you want to do, use the GNU Library General\r\n")
_T("Public License instead of this License.\r\n");

BOOL CALLBACK
LicenseDlgProc (HWND   hDlg,
                UINT   uMsg,
                WPARAM wParam,
                LPARAM lParam)
{
  static POINT ptMin;
  static DLGITEMPOSITION dipLicence[6] = {
            {IDC_EDIT11,        TRUE,  TRUE,  TRUE,  TRUE, 0, 0, 0, 0, 0, 0},
            {IDC_RADIOBUTTON11, TRUE,  FALSE, FALSE, TRUE, 0, 0, 0, 0, 0, 0},
            {IDC_RADIOBUTTON12, TRUE,  FALSE, FALSE, TRUE, 0, 0, 0, 0, 0, 0},
            {IDOK,              FALSE, FALSE, TRUE,  TRUE, 0, 0, 0, 0, 0, 0},
            {IDCANCEL,          FALSE, FALSE, TRUE,  TRUE, 0, 0, 0, 0, 0, 0},
            {IDC_STATUS11,      TRUE,  FALSE, TRUE,  TRUE, 0, 0, 0, 0, 0, 0}};

  switch (uMsg)
    {
      case WM_INITDIALOG:
        {
          int x, y;
          RECT rc;

          /* ja:EChE̍ŏlۑ */
          if (!GetWindowRect (hDlg, &rc))
            {
              EndDialog (hDlg, IDCANCEL);
              return TRUE;
            }
          ptMin.x = rc.right - rc.left;
          ptMin.y = rc.bottom - rc.top;
          /* ja:ʒu */
          if (!InitDlgItemPosition (hDlg, dipLicence, 6))
            {
              EndDialog (hDlg, IDCANCEL);
              return TRUE;
            }
          /* ja:EChE𒆉ɕ\ */
          x = GetSystemMetrics (SM_CXSCREEN);
          y = GetSystemMetrics (SM_CYSCREEN);
          if (!SetWindowPos (hDlg, 0, x / 6, y / 6, x * 2 / 3, y * 2 / 3,
                                                                SWP_NOZORDER))
            {
              EndDialog (hDlg, IDCANCEL);
              return TRUE;
            }
          if (!SetDlgItemText (hDlg, IDC_EDIT11, lpszGnuGpl))
            {
              EndDialog (hDlg, IDCANCEL);
              return TRUE;
            }
        }
        return TRUE;
      case WM_GETMINMAXINFO:
        ((LPMINMAXINFO)lParam)->ptMinTrackSize = ptMin;
        return 0;
      case WM_SIZE:
        if (!SetDlgItemPosition (hDlg, dipLicence, 6))
          EndDialog (hDlg, IDCANCEL);
        return 0;
      case WM_COMMAND:
        switch (LOWORD (wParam))
          {
            case IDOK:
              if (IsDlgButtonChecked (hDlg, IDC_RADIOBUTTON11) == BST_CHECKED)
                {
                  EndDialog (hDlg, IDOK);
                  return TRUE;
                }
            case IDCANCEL:
              EndDialog (hDlg, IDCANCEL);
              return TRUE;
          }
        return TRUE;
    }
  return FALSE;
}


BOOL CALLBACK
LicensedDlgProc (HWND   hDlg,
                 UINT   uMsg,
                 WPARAM wParam,
                 LPARAM lParam)
{
  static POINT ptMin;
  static DLGITEMPOSITION dipLicence[4] = {
            {IDC_EDIT11,   TRUE,  TRUE,  TRUE, TRUE, 0, 0, 0, 0, 0, 0},
            {IDOK,         FALSE, FALSE, TRUE, TRUE, 0, 0, 0, 0, 0, 0},
            {IDCANCEL,     FALSE, FALSE, TRUE, TRUE, 0, 0, 0, 0, 0, 0},
            {IDC_STATUS11, TRUE,  FALSE, TRUE, TRUE, 0, 0, 0, 0, 0, 0}};

  switch (uMsg)
    {
      case WM_INITDIALOG:
        {
          int x, y;
          RECT rc;

          /* ja:WI{^A[Jp̃{^\ɂ */
          if (!ShowDlgItem (hDlg, IDC_RADIOBUTTON11, SW_HIDE)
                            || !ShowDlgItem (hDlg, IDC_RADIOBUTTON12, SW_HIDE)
                                        || !ShowDlgItem (hDlg, IDOK, SW_HIDE))
            {
              EndDialog (hDlg, IDCANCEL);
              return TRUE;
            }
          /* ja:LZ̕\ς */
          if (!SetDlgItemText (hDlg, IDCANCEL,
                                LoadText ((HINSTANCE)lParam, IDS_LICENSED)))
            {
              EndDialog (hDlg, IDCANCEL);
              return TRUE;
            }
          /* ja:EChE̍ŏlۑ */
          if (!GetWindowRect (hDlg, &rc))
            {
              EndDialog(hDlg,IDCANCEL);
              return TRUE;
            }
          ptMin.x = rc.right - rc.left;
          ptMin.y = rc.bottom - rc.top;
          /* ja:ʒu */
          if (!InitDlgItemPosition (hDlg, dipLicence, 4))
            {
              EndDialog (hDlg, IDCANCEL);
              return TRUE;
            }
          /* ja:EChE𒆉ɕ\ */
          x = GetSystemMetrics (SM_CXSCREEN);
          y = GetSystemMetrics (SM_CYSCREEN);
          if (!SetWindowPos (hDlg, 0, x / 6, y / 6, x * 2 / 3, y * 2 / 3,
                                                                SWP_NOZORDER))
            {
              EndDialog (hDlg, IDCANCEL);
              return TRUE;
            }
          if (!SetDlgItemText (hDlg, IDC_EDIT11, lpszGnuGpl))
            {
              EndDialog (hDlg, IDCANCEL);
              return TRUE;
            }
        }
        return TRUE;
      case WM_GETMINMAXINFO:
        ((LPMINMAXINFO)lParam)->ptMinTrackSize = ptMin;
        return 0;
      case WM_SIZE:
        if (!SetDlgItemPosition (hDlg, dipLicence, 4))
          EndDialog (hDlg, IDCANCEL);
        return 0;
      case WM_COMMAND:
        if (LOWORD (wParam) == IDCANCEL)
          EndDialog (hDlg, IDCANCEL);
        return TRUE;
    }
  return FALSE;
}
